
import org.infinispan.Cache;
import org.infinispan.config.Configuration;
import org.infinispan.config.GlobalConfiguration;
import org.infinispan.manager.DefaultCacheManager;
import org.infinispan.manager.EmbeddedCacheManager;

@SuppressWarnings({"unchecked", "rawtypes"})
public class LosingDataWhenNewNodeDiscardedOnJoin {

    public static void main(String[] args) throws InterruptedException {
        new LosingDataWhenNewNodeDiscardedOnJoin().bug();
    }
    
    public void bug() throws InterruptedException {
        EmbeddedCacheManager cm1 = newCM();
        Configuration c = new Configuration().fluent()
        .mode(Configuration.CacheMode.DIST_SYNC)
        .hash().numOwners(1)
        .clustering().l1().disable()
        .build();
        cm1.defineConfiguration("c", c);
        Cache c1 = cm1.getCache("x");
        c1.put("key", "1");

        System.out.println("c1="+c1.get("key"));

        Thread.sleep(1000);
        
        EmbeddedCacheManager cm2 = newCM();
        Cache c2 = cm2.getCache("x");
        
        Object v1 = c1.get("key");
        Object v2 = c2.get("key");
        System.out.println("c1="+v1+" c2="+v2);
        
        cm1.stop();
  
        //Question: how to force data to move off c1? how to force where it moves to?
//        System.out.println("c2 - "+c2.get("key"));
        cm2.stop();
        
        assert v1!=null : "value at cache 1 was lost";
    }
    
    public EmbeddedCacheManager newCM() {
        GlobalConfiguration gc = GlobalConfiguration.getClusteredDefault();
        Configuration c = new Configuration().fluent()
            .mode(Configuration.CacheMode.DIST_SYNC)
            .hash().numOwners(1)
            .clustering().l1().disable()
            .build();
        return new DefaultCacheManager(gc, c);
    }
}
